
local yeetedHuds = {"score", "time", "rings", "lives"}

local hudsYeeted = false

hud.add(function (v, player)
	if not (player and player.valid and player.realmo) then return end 
	if player.mo.skin ~= "alm" then
        if hudsYeeted then
            for i = 1, #yeetedHuds do
                hud.enable(yeetedHuds[i])
            end
        end
		return
	end
	
	hudsYeeted = true
	for _, hudname in pairs(yeetedHuds) do
		hud.disable(hudname)
	end
	
	if player.pstate == PST_DEAD or player.spectator then return end
	
	local hp = max(1, min(4, player.hp or 4))
	
	local patch = v.cachePatch("HATINTIME_HP" .. hp)
	
	v.drawScaled(
		25*FU, 25*FU,
		FU/2 + (player.iGotHitABitAgo or 0) * (FU/64),
		patch,
		V_SNAPTOTOP | V_SNAPTOLEFT
	)
	
end, "game")