freeslot("sfx_almow1", "sfx_almow2", "sfx_almow3", "sfx_almow4", "sfx_almpeck1", "sfx_almpeck2", "music_colps")

addHook("PlayerThink", function (player)
	if not (player and player.valid and player.realmo) then return end 
	if player.mo.skin ~= "alm" then	return end
	if player.pstate == PST_DEAD or player.spectator then return end
	
	if not player.hp then
		player.hp = 4
	end
	
	if player.iGotHitABitAgo then
		player.iGotHitABitAgo = $ - 1
	end
	
	if player.hitfreeze then
		player.hitfreeze.tics = $ - 1
		if not player.hitfreeze.tics then
			player.mo.momx, player.mo.momy, player.mo.momz = unpack(player.hitfreeze.mom)
			player.mo.state = S_PLAY_FALL
			player.hitfreeze = nil
		else
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
		end
	end
end)

addHook("PlayerSpawn", function (player)
	if not (player and player.valid and player.realmo) then return end 
	if player.mo.skin ~= "alm" then	return end
	
	player.hp = 4
end)
	
addHook("MobjDamage", function (mo, inflictor, source, damage, damagetype)
	local player = mo.player
	if not (player and player.valid) then return end 
	if player.mo.skin ~= "alm" then	return end
	
	--will i die?
	--if not (player.rings or player.powers[pw_shield]) then return end
	if (player.hp <= 1) then
		P_KillMobj(mo, inflictor, source, damagetype)
		return true
	else
		player.hp = $ - 1
		S_StartSound(player.mo, ({sfx_almow1, sfx_almow2, sfx_almow3, sfx_almow4})[P_RandomRange(1,4)])
	end
	
	player.hitfreeze = {
		tics = TICRATE/3,
		mom = {player.mo.momx, player.mo.momy, player.mo.momz}
	}
	player.mo.momx = 0
	player.mo.momy = 0
	player.mo.momz = 0
	player.iGotHitABitAgo = 10
	P_DoPlayerPain(player)
	return true
end)

-- rewrite starts here, even though it isn't that different from the og code
-- -Pacola

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "alm" return end
	
	if (p.cmd.buttons & BT_SPIN)
		p.normalspeed = 36*FU
	else
		p.normalspeed = skins[p.mo.skin].normalspeed
	end
end)

//afterimages
//because yes

-- why would i rewrite skincolor definitions

freeslot("SKINCOLOR_AFTERIMAGERED","SKINCOLOR_AFTERIMAGEGREEN","SKINCOLOR_AFTERIMAGEPINK","SKINCOLOR_AFTERIMAGEYELLOW")

local function chooseafterimagecolor(...)
	local args = {...}
	local choice = P_RandomRange(1,#args)
	return args[choice]
end

skincolors[SKINCOLOR_AFTERIMAGERED] = {
    name = "After Image Red",
    ramp = {35,35,35,35,35,35,35,35,35,35,35,37,37,37,37,37},
    invcolor = SKINCOLOR_RED,
    invshade = 9,
    chatcolor = V_REDMAP,
    accessible = true
}

skincolors[SKINCOLOR_AFTERIMAGEGREEN] = {
    name = "After Image Green",
    ramp = {112,112,112,112,112,112,112,112,112,112,112,114,114,114,114,114},
    invcolor = SKINCOLOR_GREEN,
    invshade = 9,
    chatcolor = V_GREENMAP,
    accessible = true
}

skincolors[SKINCOLOR_AFTERIMAGEPINK] = {
    name = "After Image Pink",
    ramp = {180,180,180,180,180,180,180,180,180,180,180,182,182,182,182,182},
    invcolor = SKINCOLOR_ROSY,
    invshade = 9,
    chatcolor = V_PINKMAP,
    accessible = true
}

skincolors[SKINCOLOR_AFTERIMAGEYELLOW] = {
    name = "After Image Yellow",
    ramp = {73,73,73,73,73,73,73,73,73,73,73,75,75,75,75,75},
    invcolor = SKINCOLOR_YELLOW,
    invshade = 9,
    chatcolor = V_YELLOWMAP,
    accessible = true
}

-- i didn't rewrite this either

local function createafterimage(p)
	local afti = P_SpawnGhostMobj(p.mo)
	afti.colorized = true
	afti.fuse = 90
	afti.tics = 5
	afti.color = chooseafterimagecolor(SKINCOLOR_AFTERIMAGEYELLOW,SKINCOLOR_AFTERIMAGERED,SKINCOLOR_AFTERIMAGEPINK,SKINCOLOR_AFTERIMAGEGREEN)
	afti.frame = TR_TRANS40|p.mo.frame|FF_FULLBRIGHT
end

-- i didn't really rewrite this

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "alm" return end
	
	if p.speed > 28*FU
	and leveltime%5 == 0
		createafterimage(p)
	end
end)

freeslot("sfx_astep")
sfxinfo[sfx_astep].caption = "Step"

local function walkframes(p)
	if (p.mo.frame == B or p.mo.frame == D or p.mo.frame == E or p.mo.frame == F or p.mo.frame == H)
		return true
	else
		return false
	end
end

local function runframes(p)
	if (p.mo.frame == B or p.mo.frame == D)
		return true
	else
		return false
	end
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "alm" return end
	
	if ((walkframes(p) and p.mo.state == S_PLAY_WALK)
	or (runframes(p) and p.mo.state == S_PLAY_RUN))
	and not p.feetstep
	and P_IsObjectOnGround(p.mo)
		S_StartSound(p.mo, sfx_astep)
		p.feetstep = true
		P_SpawnSkidDust(p, FU)
	elseif not walkframes(p)
		p.feetstep = false
	end
end)

freeslot("S_ALM_CHARGE", "SPR2_CHAG")

states[S_ALM_CHARGE] = {
    sprite = SPR_PLAY,
    frame = SPR2_CHAG,
    tics = -1,
    nextstate = S_ALM_CHARGE
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "alm" return end
	
	if p.dashcharge == nil
		p.dashcharge = false
	end
	
	if p.panim == PA_IDLE
	and P_IsObjectOnGround(p.mo)
	and not ((p.pflags & PF_STASIS) or (p.pflags & PF_FULLSTASIS))
	and not p.dashcharge
	and (p.cmd.buttons & BT_CUSTOM1)
		p.dashcharge = true
		S_StartSound(p.mo, sfx_cdfm11)
		return true
	end
	
	if p.dashcharge
		p.drawangle = p.mo.angle
		p.mo.state = S_ALM_CHARGE
		p.pflags = $1|PF_FULLSTASIS
		P_SpawnSkidDust(p, 17*FU)
		if not (p.cmd.buttons & BT_CUSTOM1)
			p.dashcharge = false
			p.woag = true
			P_InstaThrust(p.mo, p.mo.angle, 42*FU)
			P_MovePlayer(p)
			S_StartSound(p.mo, sfx_cdfm01)
		end
	end
	
	if (p.cmd.buttons & BT_CUSTOM1)
		p.woagc1held = $+1
	else
		p.woagc1held = 0
	end
	
	if p.woag == nil
		p.woag = false
	end
	if p.woag
		if p.mo.state ~= S_PLAY_DASH
			p.mo.state = S_PLAY_DASH
			p.powers[pw_strong] = $1|STR_SPIKE|STR_ANIM
		end
		p.drawangle = p.mo.angle
		p.pflags = $1|PF_JUMPSTASIS
		P_InstaThrust(p.mo, p.mo.angle, 42*FU)
		if p.woagc1held == 1
			p.woag = false
			p.mo.state = S_PLAY_RUN
		end
		if p.powers[pw_pushing]
			p.woag = false
			P_DoPlayerPain(p)
			S_StartSound(p.mo, sfx_s3k5f)
		end
	end
end)

addHook("PlayerThink", function(p) -- i didnt even rewrite this, i just added the (p.mo and p.mo.valid) check
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "alm" return end
	
	if p.playerstate == PST_DEAD
	or p.powers[pw_carry]
	or P_PlayerInPain(p)
		p.dashcharge = false
		p.woag = false
	end
end)

-- end of rewrite
-- -Pacola

addHook("PlayerCanDamage", function(p)
	if p.woag
		return true
	end
end)

addHook("TouchSpecial", function(special, toucher)
	if toucher and toucher.valid
	and toucher.player and toucher.player.valid
	and toucher.skin == "alm"
	and special and special.valid
	and toucher.player.hp < 4
		toucher.player.hp = $ + 1
	end
end, MT_RING)